#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.8"
#define MAX_PLAYERS 64

// decap cvars
new Handle:cvDecapHeadshot = INVALID_HANDLE;
new Handle:cvDecapKnife = INVALID_HANDLE;
new Handle:cvDecapHE = INVALID_HANDLE;
new Handle:PlayersDMG = INVALID_HANDLE;

// player data
new g_HeadEnt[MAX_PLAYERS+1];				// players head
new g_HeadLastHolder[MAX_PLAYERS+1];		// who most recently held this


public Plugin:myinfo = 
{
	name = "Zombie:DecapiTation",
	author = "msi morkva, Scarface_slv (HLModders.ru LLC)",
	description = "Zombie:DecapiTation",
	version = PLUGIN_VERSION,
	url = "http://hlmod.ru/forum/"
};

// plugin events
public OnPluginStart()
{
	PrintToConsole(0, "[ZR] Zombie:DecapiTation loaded.");
	
	CreateConVar("sm_decap_version", PLUGIN_VERSION, "Zombie:DecapiTation Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);

	cvDecapHeadshot = CreateConVar("sm_decap_headshot", "1", "decapination on headshot");
	cvDecapKnife = CreateConVar("sm_decap_knife", "1", "decapination on knifing");
	cvDecapHE = CreateConVar("sm_decap_he", "1", "decapination on grenade");
	PlayersDMG = CreateConVar( "sm_decap_dmg", "5", "decapination on dmg", 0, true, 1.0, true, 3500.0);

	HookEvent("player_hurt", EventPlayerHurt, EventHookMode_Pre);
	HookEvent("round_start", EventRoundStart);
	HookEvent("player_death", EventDeath);
	HookEvent("player_spawn", EventSpawn);
	HookEvent("player_team", EventSpawn);
	
}

public OnEventShutdown()
{
	UnhookEvent("player_hurt", EventPlayerHurt, EventHookMode_Pre);
	UnhookEvent("round_start", EventRoundStart);
	UnhookEvent("player_death", EventDeath, EventHookMode_Pre);
	UnhookEvent("player_spawn",EventSpawn);
	UnhookEvent("player_team",EventTeam);
	
}

public OnMapStart()
{
	//open precache file and add everything to download table
	new String:modelfile[256];
	BuildPath(Path_SM, modelfile, 255, "configs/dc_assetconfig.ini");
	new Handle:fileh = OpenFile(modelfile, "r");
	new String:buffer[256];
	while (ReadFileLine(fileh, buffer, sizeof(buffer)))
	{
		new len = strlen(buffer);
		if (buffer[len-1] == '\n')
   			buffer[--len] = '\0';
   			
		if (FileExists(buffer))
		{
			AddFileToDownloadsTable(buffer);
		}
		
		if (IsEndOfFile(fileh))
			break;
	}
	
	// models
	PrecacheModel("models/player/zh/zh_charple001_hs.mdl",true);
	PrecacheModel("models/player/zh/zh_corpse002_hs.mdl",true);
	PrecacheModel("models/player/zh/zh_zombie003_hs.mdl",true);
	PrecacheModel("models/player/slow/zombie_package/slow_5_hs.mdl",true);
	PrecacheModel("models/player/lextalionis/zombine/t_phoenix_hs.mdl",true);
	PrecacheModel("models/player/ics/t_guerilla_z/t_guerilla_hs.mdl",true);
	PrecacheModel("models/player/ibizagaming/zombie/poison_v2_hs.mdl",true);
	PrecacheModel("models/player/elis/uz1/uz1_hs.mdl",true);

	PrecacheModel("models/player/zh/zh_charple001_head.mdl",true);
	PrecacheModel("models/player/zh/zh_corpse002_head.mdl",true);
	PrecacheModel("models/player/zh/zh_zombie003_head.mdl",true);
	PrecacheModel("models/player/slow/zombie_package/slow_5_head.mdl",true);
	PrecacheModel("models/player/ics/t_guerilla_z/t_guerilla_head.mdl",true);
	PrecacheModel("models/player/lextalionis/zombine/t_phoenix_head.mdl",true);
	PrecacheModel("models/player/ibizagaming/zombie/poison_v2_head.mdl",true);
	PrecacheModel("models/player/elis/uz1/uz1_head.mdl",true);
}

public ForcePrecache(String:ParticleName[])
{
	decl Particle;
	
	Particle = CreateEntityByName("info_particle_system");
	
	if(IsValidEdict(Particle))
	{
		DispatchKeyValue(Particle, "effect_name", ParticleName);
		
		DispatchSpawn(Particle);
		ActivateEntity(Particle);
		AcceptEntityInput(Particle, "start");
		
	}
}

public OnClientPutInServer(client)
{
	ResetPlayer(client);
}

public OnClientDisconnect(client)
{
	if((g_HeadEnt[client]) && (IsValidEntity(g_HeadEnt[client])))
	{
		RemoveEdict(g_HeadEnt[client]);
	}

	ResetPlayer(client);
}

public Action:EventRoundStart(Handle:Event, const String:Name[], bool:Broadcast)
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if (IsClientConnected(client) && IsClientInGame(client))
		{
		}
	}
	
	return Plugin_Continue;
}

// dont actually use this...
stock bool:IsPlayer(client)
{
	if (client <= 0) return false;
	if (client > MAXPLAYERS) return false;
	if (!IsClientConnected(client)) return false;
	return IsClientInGame(client);
}

ResetPlayer(client, bool:resetHead = true)
{
	if(resetHead)
		g_HeadEnt[client] = -1;
	g_HeadLastHolder[client] = -1;

}

public Action:RemoveRagdoll(Handle:Timer, any:client)
{
	if (!IsValidEntity(client))
		return;
	
	new String:edictname[128];

	new BodyRagdoll = GetEntPropEnt(client, Prop_Send, "m_hRagdoll");
	if(IsValidEdict(BodyRagdoll))
	{
	
		//Find:
		GetEdictClassname(BodyRagdoll, edictname, sizeof(edictname)); 

		//Remove:
		if(StrEqual(edictname, "cs_ragdoll", false)) RemoveEdict(BodyRagdoll);
	}
}

// game events
public Action:EventPlayerHurt(Handle:event, const String:name[], bool:dontBroadcast)
{
	new hitgroup = GetEventInt(event, "hitgroup");
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	new doDecap = false;
	new player_damage = GetClientHealth(victim) 
	new String:weapon[64];
	GetEventString(event, "weapon", weapon, 64);

	if((hitgroup == 1) && (GetConVarInt(cvDecapHeadshot)==1))
		doDecap = true;
	if((StrEqual(weapon, "knife", false)) && (GetConVarInt(cvDecapKnife)==1))
		doDecap = true;
	if((StrEqual(weapon, "hegrenade", false)) && (GetConVarInt(cvDecapHE)==1))
		doDecap = true;
	new String:oldmodel[256];
	new String:bodymodel[256];
	new String:headmodel[256];

	GetClientModel(victim, oldmodel, 256);

	if (StrEqual(oldmodel, "models/player/zh/zh_charple001.mdl", false))
	{
		bodymodel = "models/player/zh/zh_charple001_hs.mdl";
		headmodel = "models/player/zh/zh_charple001_head.mdl";
	}
	else if (StrEqual(oldmodel, "models/player/zh/zh_corpse002.mdl", false))
	{
		bodymodel = "models/player/zh/zh_corpse002_hs.mdl";
		headmodel = "models/player/zh/zh_corpse002_head.mdl";
	}
	else if (StrEqual(oldmodel, "models/player/zh/zh_zombie003.mdl", false))
	{
		bodymodel = "models/player/zh/zh_zombie003_hs.mdl";
		headmodel = "models/player/zh/zh_zombie003_head.mdl";
	}
	else if (StrEqual(oldmodel, "models/player/slow/zombie_package/slow_5.mdl", false))
	{
		bodymodel = "models/player/slow/zombie_package/slow_5_hs.mdl";
		headmodel = "models/player/slow/zombie_package/slow_5_head.mdl";
	}
	else if (StrEqual(oldmodel, "models/player/lextalionis/zombine/t_phoenix.mdl", false))
	{
		bodymodel = "models/player/lextalionis/zombine/t_phoenix_hs.mdl";
		headmodel = "models/player/lextalionis/zombine/t_phoenix_head.mdl";
	}
	else if (StrEqual(oldmodel, "models/player/ics/t_guerilla_z/t_guerilla.mdl", false))
	{
		bodymodel = "models/player/ics/t_guerilla_z/t_guerilla_hs.mdl";
		headmodel = "models/player/ics/t_guerilla_z/t_guerilla_head.mdl";
	}
	else if (StrEqual(oldmodel, "models/player/ibizagaming/zombie/poison_v2.mdl", false))
	{
		bodymodel = "models/player/ibizagaming/zombie/poison_v2_hs.mdl";
		headmodel = "models/player/ibizagaming/zombie/poison_v2_head.mdl";
	}
	else if (StrEqual(oldmodel, "models/player/elis/uz1/uz1.mdl", false))
	{
		bodymodel = "models/player/elis/uz1/uz1_hs.mdl";
		headmodel = "models/player/elis/uz1/uz1_head.mdl";
	}
	else
	{
		doDecap = false;
	}
	if (IsModelPrecached(bodymodel) && IsModelPrecached(headmodel) && doDecap && player_damage <= GetConVarInt(PlayersDMG))
	{
		new String:attacker_name[64];
		new String:victim_name[64];
		GetClientName(attacker, attacker_name, sizeof(attacker_name));
		GetClientName(victim, victim_name, sizeof(victim_name));
			
		if(IsPlayer(attacker))
			PrintToChatAll("\x03%s\x01 Обезглавил!~> \x04%s!", attacker_name, victim_name);
		else
			PrintToChatAll("\x03%s\x01 Потерял Голову!", victim_name);
			
		SetEntityModel(victim, bodymodel);
		GiveHead(victim, headmodel);
	}
	return Plugin_Continue;
}

public Action:EventSpawn(Handle:Event, const String:Name[], bool:Broadcast)
{
	new client = GetClientOfUserId(GetEventInt(Event, "userid"));
	ResetPlayer(client);
	return Plugin_Continue;
}

public Action:EventDeath(Handle:Event, const String:Name[], bool:Broadcast)
{
	return Plugin_Continue;
}

public Action:EventTeam(Handle:Event, const String:Name[], bool:Broadcast)
{
	new client = GetClientOfUserId(GetEventInt(Event, "userid"));

	ResetPlayer(client);
	
	return Plugin_Continue;
}

// timers
public Action:SpurtTimer(Handle:Timer, any:client)
{
	if(IsClientInGame(client) && IsClientConnected(client) && IsPlayerAlive(client))
	{
		decl health;
		health = GetClientHealth(client);

		if (health > 0)
			SetEntityHealth(client, health);
		else
			ForcePlayerSuicide(client);
	}

	return Plugin_Continue;
}

public Action:CheckPosTimer(Handle:Timer)
{
	decl Float:ClientOrigin[3];
	decl Float:HeadOrigin[3];

	for (new client = 1; client <= MaxClients; client++)
	{
		if (g_HeadEnt[client] > 0)
		{
			GetClientAbsOrigin(client,ClientOrigin);
			ClientOrigin[0] += 5.0;
			ClientOrigin[2] += 60.0;
			GetEntPropVector(g_HeadEnt[client], Prop_Send, "m_vecOrigin", HeadOrigin);
		}
	}
	
	return Plugin_Continue;
}

// decapiTation functions
public GiveHead(any:victim, String:headmodel[])
{
	g_HeadEnt[victim] = CreateEntityByName("prop_physics_override");
	SetEntityModel(g_HeadEnt[victim],headmodel);
	SetEntityMoveType(g_HeadEnt[victim], MOVETYPE_VPHYSICS);
	SetEntProp(g_HeadEnt[victim], Prop_Data, "m_CollisionGroup", 11); //TODO: CHECKME
	DispatchSpawn(g_HeadEnt[victim]);

	if(IsValidEntity(g_HeadEnt[victim]))
	{
		new Float:Client_Origin[3];
		new Float:Client_Angles[3];
		new Float:vecVelocity[3];

		GetClientAbsOrigin(victim,Client_Origin);
		GetClientAbsAngles(victim,Client_Angles);

		Client_Origin[2] += 50;

		vecVelocity[0] = GetRandomFloat(-130.0,130.0);
		vecVelocity[1] = GetRandomFloat(-130.0,130.0);
		vecVelocity[2] = GetRandomFloat(100.0,250.0);
		
		TeleportEntity(g_HeadEnt[victim], Client_Origin, Client_Angles, vecVelocity);
		
	}
}

public ReattachHead(any:client)
{
	if(IsClientInGame(client) && IsClientConnected(client))
	{
		new String:oldmodel[256];
		new String:bodymodel[256];

		GetClientModel(client, oldmodel, 256);

		if (StrEqual(oldmodel, "models/player/zh/zh_charple001.mdl", false))
		{
			bodymodel = "models/player/zh/zh_charple001_hs.mdl";
		}
		else if (StrEqual(oldmodel, "models/player/zh/zh_corpse002.mdl", false))
		{
			bodymodel = "models/player/zh/zh_corpse002_hs.mdl";
		}
		else if (StrEqual(oldmodel, "models/player/zh/zh_zombie003.mdl", false))
		{
			bodymodel = "models/player/zh/zh_zombie003_hs.mdl";
		}
		else if (StrEqual(oldmodel, "models/player/slow/zombie_package/slow_5.mdl", false))
		{
			bodymodel = "models/player/slow/zombie_package/slow_5_hs.mdl";
		}
		else if (StrEqual(oldmodel, "models/player/lextalionis/zombine/t_phoenix.mdl", false))
		{
			bodymodel = "models/player/lextalionis/zombine/t_phoenix_hs.mdl";
		}
		else if (StrEqual(oldmodel, "models/player/ics/t_guerilla_z/t_guerilla.mdl", false))
		{
			bodymodel = "models/player/ics/t_guerilla_z/t_guerilla_hs.mdl";
		}
		else if (StrEqual(oldmodel, "models/player/ibizagaming/zombie/poison_v2.mdl", false))
		{
			bodymodel = "models/player/ibizagaming/zombie/poison_v2_hs.mdl";
		}
		else if (StrEqual(oldmodel, "models/player/elis/uz1/uz1.mdl", false))
		{
			bodymodel = "models/player/elis/uz1/uz1_hs.mdl";
		}
	
		if (IsModelPrecached(bodymodel))
		{
			SetEntityModel(client, bodymodel);
		}

		if((g_HeadEnt[client]) && (IsValidEntity(g_HeadEnt[client])))
		{
			RemoveEdict(g_HeadEnt[client]);
		}
		
		g_HeadEnt[client] = -1;
		g_HeadLastHolder[client] = -1;

	}
}